import { effectScope, onScopeDispose, readonly, ref, toRaw, watch, watchEffect } from 'vue';
import { getCurrentInstance } from "../util/index.mjs"; // Types

const stack = ref([]);
export function useStack(isActive) {
  const vm = getCurrentInstance('useStack');
  let scope;
  watch(isActive, val => {
    if (val) {
      scope = effectScope();
      scope.run(() => {
        stack.value.push(vm);
        onScopeDispose(() => {
          const idx = stack.value.indexOf(vm);
          stack.value.splice(idx, 1);
        });
      });
    } else {
      var _scope;

      (_scope = scope) == null ? void 0 : _scope.stop();
    }
  }, {
    immediate: true
  });
  const isTop = ref(true);
  watchEffect(() => {
    const _isTop = toRaw(stack.value[stack.value.length - 1]) === vm;

    setTimeout(() => isTop.value = _isTop);
  });
  return {
    isTop: readonly(isTop)
  };
}
//# sourceMappingURL=stack.mjs.map